#!/bin/bash

gp_test "sort" "random-list" "sorted"
gp_test "sort" "sorted-list" "sorted"
gp_test "sort" "reversed-list" "sorted"

gp_test "isort" "random-list" "sorted"
gp_test "isort" "sorted-list" "sorted"
gp_test "isort" "reversed-list" "sorted"

gp_test "inverse" "empty" "empty"
gp_test "inverse" "discrete-6" "discrete-6"
gp_test "inverse" "random-list" "random-list-reversed"
gp_test "inverse" "int-square" "int-square-reversed"
gp_test "inverse" "example" "example-reversed"
gp_test "inverse" "k4" "k4-reversed"
gp_test "inverse" "circuit" "circuit"

gp_test "colour" "empty" "empty"
gp_test "colour" "discrete-6" "discrete-6-coloured"
gp_test "colour" "random-list" "random-list-coloured-1" "random-list-coloured-2"
gp_test "colour" "int-square" "int-square-coloured-1" "int-square-coloured-2"
gp_test "colour" "example" "example-coloured-1" "example-coloured-2"
gp_test "colour" "k4" "k4-coloured-1" "k4-coloured-2"
gp_test "colour" "circuit" "circuit-coloured-1" "circuit-coloured-2"

gp_test "is-discrete" "empty" "empty"
gp_test "is-discrete" "discrete-1" "empty"
gp_test "is-discrete" "discrete-6" "empty"
gp_test "is-discrete" "int-square" "fail"
gp_test "is-discrete" "example" "fail"
gp_test "is-discrete" "reversed-list" "fail"
gp_test "is-discrete" "circuit" "fail"

gp_test "is-series-par" "empty" "del-fail"
gp_test "is-series-par" "discrete-1" "del-fail"
gp_test "is-series-par" "discrete-6" "del-fail"
gp_test "is-series-par" "int-square" "del-fail"
gp_test "is-series-par" "example" "del-fail"
gp_test "is-series-par" "reversed-list" "empty"
gp_test "is-series-par" "circuit" "empty"

gp_test "is-cycle-slow" "empty" "red1-fail"
gp_test "is-cycle-slow" "list" "red1-fail"
gp_test "is-cycle-slow" "tree-4" "red1-fail"
gp_test "is-cycle-slow" "wide-tree" "red1-fail"
gp_test "is-cycle-slow" "grid-6" "red1-fail"
gp_test "is-cycle-slow" "discrete-1-grey" "red1-fail"
gp_test "is-cycle-slow" "cycle-1" "empty"
gp_test "is-cycle-slow" "cycle-2" "empty"
gp_test "is-cycle-slow" "cycle-20" "empty"

gp_test "is-cycle" "empty" "init-fail"
gp_test "is-cycle" "list" "red1-fail"
gp_test "is-cycle" "tree-4" "red1-fail"
gp_test "is-cycle" "wide-tree" "red1-fail"
gp_test "is-cycle" "grid-6" "red1-fail"
gp_test "is-cycle" "discrete-1-grey" "red1-fail"
gp_test "is-cycle" "cycle-1" "empty"
gp_test "is-cycle" "cycle-2" "empty"
gp_test "is-cycle" "cycle-20" "empty"

gp_test "is-tree-old" "empty" "init-fail"
gp_test "is-tree-old" "list" "gen-4-grey"
gp_test "is-tree-old" "tree-4" "gen-0-grey"
gp_test "is-tree-old" "wide-tree" "grey-root"
gp_test "is-tree-old" "grid-6" "fail"
gp_test "is-tree-old" "discrete-1-grey" "gen-1-grey"
gp_test "is-tree-old" "cycle-1" "fail"
gp_test "is-tree-old" "cycle-2" "fail"
gp_test "is-tree-old" "cycle-20" "fail"

gp_test "is-tree" "empty" "init-fail"
gp_test "is-tree" "list" "gen-4-blue"
gp_test "is-tree" "tree-4" "gen-0-blue"
gp_test "is-tree" "wide-tree" "blue-root"
gp_test "is-tree" "grid-6" "fail"
gp_test "is-tree" "discrete-1-grey" "gen-1-blue"
gp_test "is-tree" "cycle-1" "init-fail"
gp_test "is-tree" "cycle-2" "init-fail"
gp_test "is-tree" "cycle-20" "init-fail"

gp_test "is-bin-dag" "empty" "empty"
gp_test "is-bin-dag" "list" "empty"
gp_test "is-bin-dag" "tree-4" "empty"
gp_test "is-bin-dag" "wide-tree" "fail"
gp_test "is-bin-dag" "grid-6" "empty"
gp_test "is-bin-dag" "discrete-1-grey" "empty"
gp_test "is-bin-dag" "cycle-1" "fail"
gp_test "is-bin-dag" "cycle-2" "fail"
gp_test "is-bin-dag" "cycle-20" "fail"

gp_test "is-dag" "empty" "empty"
gp_test "is-dag" "list" "searched-list"
gp_test "is-dag" "tree-4" "searched-tree-4"
gp_test "is-dag" "wide-tree" "searched-wide-tree"
gp_test "is-dag" "grid-6" "searched-grid-6"
gp_test "is-dag" "discrete-1-grey" "searched-discrete-1-grey"
gp_test "is-dag" "cycle-1" "fail"
gp_test "is-dag" "cycle-2" "fail"
gp_test "is-dag" "cycle-20" "fail"

gp_test "tree-gen" "gen-0" "tree-0"
gp_test "tree-gen" "gen-1" "tree-1"
gp_test "tree-gen" "gen-4" "tree-4"
gp_test "tree-gen-grey" "gen-0-grey" "tree-0-grey"
gp_test "tree-gen-grey" "gen-1-grey" "tree-1-grey"
gp_test "tree-gen-grey" "gen-4-grey" "tree-4-grey"

gp_test "grid-gen" "gen-1" "grid-1"
gp_test "grid-gen" "gen-4" "grid-4"
gp_test "grid-gen" "gen-6" "grid-6"
gp_test "grid-gen-grey" "gen-1-grey" "grid-1-grey"
gp_test "grid-gen-grey" "gen-4-grey" "grid-4-grey"
gp_test "grid-gen-grey" "gen-6-grey" "grid-6-grey"

gp_test "dfs" "empty" "init-fail"
gp_test "dfs" "dfs-triangle" "triangle-dfs"
gp_test "dfs" "dfs-example" "dfs-example-1" "dfs-example-2"

gp_test "is-connected" "empty" "empty"
gp_test "is-connected" "short-list" "short-list-con-1" "short-list-con-2"
gp_test "is-connected" "grey-triangle" "triangle-con"
gp_test "is-connected" "grey-square" "square-con-1" "square-con-2"
gp_test "is-connected" "grey-example" "fail"

gp_test "2-colour" "empty" "empty"
gp_test "2-colour" "list" "list-col-1" "list-col-2"
gp_test "2-colour" "tree-1" "tree-1-col-1" "tree-1-col-2"
gp_test "2-colour" "tree-4" "tree-4-col"
gp_test "2-colour" "grid-4-grey" "grid-4-col"
gp_test "2-colour" "cycle-3" "cycle-3"
gp_test "2-colour" "cycle-4" "cycle-4-col-1" "cycle-4-col-2"
gp_test "2-colour" "grey-sun" "grey-sun"

gp_test "2-colour-grat" "empty" "empty"
gp_test "2-colour-grat" "list" "list-col-grat-1" "list-col-grat-2"
gp_test "2-colour-grat" "tree-1" "tree-1-col-grat-1" "tree-1-col-grat-2"
gp_test "2-colour-grat" "tree-4" "tree-4-grat-col"
gp_test "2-colour-grat" "grid-4-grey" "grid-4-grat-col"
gp_test "2-colour-grat" "cycle-3" "cycle-3"
gp_test "2-colour-grat" "cycle-4" "cycle-4-col-grat-1" "cycle-4-col-grat-2"
gp_test "2-colour-grat" "grey-sun" "grey-sun"

gp_test "inverse" "empty" "empty"
gp_test "inverse" "discrete-6" "discrete-6"
gp_test "inverse" "random-list" "random-list-reversed"
gp_test "inverse" "int-square" "int-square-reversed"
gp_test "inverse" "example" "example-reversed"
gp_test "inverse" "k4" "k4-reversed"
gp_test "inverse" "circuit" "circuit"

gp_test "top-sort" "empty" "init-fail"
gp_test "top-sort" "discrete-1-grey" "sorted-discrete-1-grey"
gp_test "top-sort" "list" "sorted-list"
gp_test "top-sort" "tree-4" "sorted-tree-4"
gp_test "top-sort" "wide-tree" "sorted-wide-tree-1" "sorted-wide-tree-2" "sorted-wide-tree-3"
gp_test "top-sort" "grid-6" "sorted-grid-6-1" "sorted-grid-6-2" "sorted-grid-6-3"

gp_test "trans-closure" "empty" "empty"
gp_test "trans-closure" "triangle" "triangle-closure"
gp_test "trans-closure" "int-square" "int-square-closure"
gp_test "trans-closure" "example" "example-closure"

gp_test "acyclic" "empty" "yes"
gp_test "acyclic" "triangle" "no"
gp_test "acyclic" "int-square" "no"
gp_test "acyclic" "random-list" "yes"

gp_test "eulerian-cycle" "empty" "empty"
gp_test "eulerian-cycle" "eulerian-cycle-1" "eulerian-cycle-1"
gp_test "eulerian-cycle" "eulerian-cycle-2" "eulerian-cycle-2-1" "eulerian-cycle-2-2" "eulerian-cycle-2-3"
gp_test "eulerian-cycle" "eulerian-cycle-3" "eulerian-cycle-3"
gp_test "eulerian-cycle" "eulerian-cycle-4" "eulerian-cycle-4-1" "eulerian-cycle-4-2" "eulerian-cycle-4-3"
gp_test "eulerian-cycle" "eulerian-cycle-5" "eulerian-cycle-5-1" "eulerian-cycle-5-2" "eulerian-cycle-5-3"

gp_test "sierpinski" "gen-1" "sierpinski-1"
gp_test "sierpinski" "gen-2" "sierpinski-2"
